//------------------------------------------------------------------------------
//	File:					mesh.cpp
//	Date:					3/23/99
//	Author:				Chris Phillips
//
//	Description:
//
//------------------------------------------------------------------------------

#include	"common.h"
#include	"Mesh.h"
#include	"Math3d.h"
#include <GL/gl.h>
#include <GL/glu.h>

//------------------------------------------------------------------------------
//	variables
//------------------------------------------------------------------------------

Mesh::Mesh()
{
	num_verts = 0;
	num_faces = 0;
	dlist=NULL;
	verts = NULL;
	faces = NULL;
	normals = NULL;
}

Mesh::~Mesh()
{
	if (dlist)
		glDeleteLists(dlist,1);
	if (verts)
		delete [] verts;
	if (faces)
		delete [] faces;
	if (normals)
		delete [] normals;
}

int Mesh::start_dlist()
{
	if(dlist)
		{
//		LogPrintf("warning:Mesh DLIST reinit\n");
		glDeleteLists(dlist,1);
		}
	dlist=glGenLists(1);
	if(dlist==0)
		return(FALSE);
	glNewList(dlist,GL_COMPILE);

//these must be removed soon.
glMatrixMode(GL_MODELVIEW);
glDisable(GL_TEXTURE_2D);
//these must be removed soon.


	return(dlist);
}
void Mesh::end_dlist()
{
	glEndList();
}




void Mesh::create( float *va,int nv,  int *fa, int nf)
{
	num_verts = nv;
	num_faces = nf;
	
	verts = new float [nv*3];
	faces = new int [nf*3];

	int i;
	for (i=0; i<nv*3; i++)
		verts[i] = va[i];

	for (i=0; i<nf*3; i++)
		faces[i] = fa[i];

	calc_normals();
}

void Mesh::draw(void)
{
	if(dlist)
   	glCallList(dlist);
}


void Mesh::calc_normals(void)
{
}


