// siall.c
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "common.h"
#include "oglview.h"
#include "mesh.h"
#include "buffer.h"
#include "binfile.h"
#include "log.h"

static Mesh siobjects[0x8000];

int siobj_parse(Buffer &buf);

int sires_load_all_file(char *name)
{
int id;
int i;

	LogPrintf("Loading .ALL:%s\n",name);

	Buffer buf;
	if(!buf.load_file(name))
		return(FALSE);

	int num=buf.next_word();

	LogPrintf("Loading %x res's\n",num);

	ushort *ids=(ushort*)&buf.data[2];
	ulong *offsets=(ulong*)&buf.data[2+(num*2)];

	for(i=0;i<num;i++)
		{
      id=ids[i];
//		LogPrintf("Decoding %04x from %08x\n",id,offsets[i]);
		if(id<0x8000)
			{
			siobjects[id].start_dlist();

			buf.pos=offsets[i];
			siobj_parse(buf);

			siobjects[id].end_dlist();
			}
		}
	return(TRUE);
}

int sires_load(char *name)
{
int i;
ulong *offsets;

	LogPrintf("Loading %s\n",name);

	if(strstr(name,".all")!=0)
		return(sires_load_all_file(name));

	Buffer buf;
	if(!buf.load_file(name))
		return(FALSE);

	ushort w=buf.next_word();
	if(w!=(((ushort)'R')|(((ushort)'S')<<8)))	//Signature.
		return(FALSE);

	int id=buf.next_byte()<<8;	//id range
	int num=buf.next_byte();	//number of items.

	if(id>0xf)
		offsets=(ulong*)&buf.data[8];
	else
		offsets=(ulong*)&buf.data[4];

//	id=id+1;
	id=id+2;

	for(i=0;i<num;i++)
		{
//		LogPrintf("Decoding %04x from %08x\n",id,offsets[i]);
		if(id<0x8000)
			{
			siobjects[id].start_dlist();

			buf.pos=offsets[i];
			siobj_parse(buf);

			siobjects[id].end_dlist();
			}
      id++;
		}
	return(TRUE);
}

void sires_draw(int shape)
{
	if(siobjects[shape].dlist)
		current_view->draw(siobjects[shape]);
}

void sires_draw_all()
{
int i;
int count=0;

	for(i=0;i<0x8000;i++)
//	for(i=0x32d;i<0x32f;i++)
		if(siobjects[i].dlist)
			{
			current_view->draw(siobjects[i]);
//		current_view->draw(siobjects[0x3c6]);
			glTranslatef(30.0,0.0,0.0);
			count++;
			if(count>25)
				{
				glTranslatef(-30.0*count,0.0,30.0);
				count=0;
				}
			}
}





