#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include "thor.h"
#include "polygon.h"
#include "mesh.h"
#include "vector.h"
#include "sires.h"
#include "sipal.h"
#include "siobj.h"

//todo
// add option to auto remove detail polys
// support lines block circle and sphere in that order.


	//convert scale constant to a mulitplier
static float scale_table[]={
	10.0,		 //0
	5.0,  	 //1
	5.0/2.0,  //2
	5.0/4.0,  //3
	5.0/8.0,  //4
	5.0/16.0,  //5
	5.0/32.0,  //6
	5.0/64.0,  //7
	5.0/128.0,  //8
	5.0/256.0,  //9
	5.0/512.0,  //10
	5.0/1024.0,  //11
	5.0/2048.0,  //12
	5.0/4096.0,  //13
	5.0/8192.0,  //14
	5.0/16384.0, //15
	5.0/32768.0, //16
	5.0/(32768.0*2), //17
	};


char *sod_op_desc[]={
"clr","get","put","int","add","sub","neg","shl","shr",//>			;0
"blokadd","blokneg","ipg","checkpoint",//>				;9
"vectors","pushcentre","popcentre","movecentre",//>			;13
"perspec","moveto","lineto",//>					;17
"linecol","zlineto","hugelineto","vlineto",//>			;20
"votevis","votehid","poly","polyz","sphere",//>			;24
"disc","perfdisc","side","initdisc","fillcol","normals","misty",//>	;29
"shade1","shade2","shades","gouraud","shadepoly","airbrush",//>		;36
"bhid","bvis","sorton","return","goto","gosub",//>			;42
"rejvec","rej3d","rej2d","hugerej3d","fractal","roty",//>		;48
"pushrelmat","poprelmat","animate",//>				;54
"hugevecs","hugeperspec",//>					;57
"hugepoly","rejhugepoly","gndhugepoly",//>			;59
"tap","hugetap",//>						;62
"polysl","polyzsl","spheresl","discsl","perfdiscsl",//>		;64
"sidesl","pushsl","popsl","dispsl",//>				;69
"intsl","subsl","addsl","dupsl",//>					;73
"shade16","shadepoly16","shade216","dot","block",//>			;77
"rotx","rotz","bvlt","bvgt","wideline","splitquad","bzlt","scaleit",//>	;82
"sprite","texture",//>

"vecellipse,vecellsl,letter",//>
"vectors2d,clr2d,get2d,put2d,int2d",//>
"add2d,sub2d,shl2d,shr2d,blokadd2d",//>
"circle,circlesl"//>
};

//static void conprintf(const char *format, ...)
//{
//}
	//C versions of the model opcodes
static void set_vert(SIVERTEX *v,int x,int y,int z)
{
	v->x=x;v->y=y;v->z=z;
	v->flags=TRUE;
}

static void get_vert(SIVERTEX *d,SIVERTEX *s)
{
	d->x=s->x;
	d->y=s->y;
	d->z=s->z;
	if(!s->flags)
		conprintf("Getting for Un-inited vert");

	d->flags=TRUE;

}
static void mid_vert(SIVERTEX *d,SIVERTEX *s)
{
SIVERTEX t;

	if(!s->flags || !d->flags)
		conprintf("Miding Un-inited vert");

		//c=a-b;c=c/2;return(a+c);
 	t.x=(s->x-d->x)/2;
	t.y=(s->y-d->y)/2;
	t.z=(s->z-d->z)/2;
	
	d->x+=t.x;
	d->y+=t.y;
	d->z+=t.z;

}

static void add_vert(SIVERTEX *d,SIVERTEX *s)
{
SIVERTEX t;

	if(!s->flags || !d->flags)
		conprintf("Miding Un-inited vert");
		//c=a-b;c=c/2;return(a+c);

	t.x=(s->x+d->x);
	t.y=(s->y+d->y);
	t.z=(s->z+d->z);
	
	d->x=t.x;
	d->y=t.y;
	d->z=t.z;

}


static void sub_vert(SIVERTEX *d,SIVERTEX *s)
{
SIVERTEX t;

	if(!s->flags || !d->flags)
		conprintf("Miding Un-inited vert");
		//c=a-b;c=c/2;return(a+c);

	t.x=(d->x-s->x);
	t.y=(d->y-s->y);
	t.z=(d->z-s->z);
	
	d->x=t.x;
	d->y=t.y;
	d->z=t.z;

}
static void neg_vert(SIVERTEX *v)
{
	if(!v->flags)
		conprintf("neging Un-inited vert");
	v->x=-v->x;
	v->y=-v->y;
	v->z=-v->z;
}
static void shr_vert(SIVERTEX *v,int s)
{
	if(!v->flags)
		conprintf("neging Un-inited vert");
	v->x=v->x>>s;
	v->y=v->y>>s;
	v->z=v->z>>s;
}
static void shl_vert(SIVERTEX *v,int s)
{
	if(!v->flags)
		conprintf("neging Un-inited vert");
	v->x=v->x<<s;
	v->y=v->y<<s;
	v->z=v->z<<s;
}

static void dump_vert(SIVERTEX *v)
{
	if(!v->flags)
		conprintf("Dumping Un-inited vert");
	conprintf("--->%d,%d,%d",v->x,v->y,v->z);
}

void siobj_test()
{
//	siobj_load("temp");
	exit(-1);
}

SIPOLY polys[2000];
int poly_index=0;
SIVERTEX verts[2000];
SIVERTEX cur_vert;
static float scale=1.0;
static int indent=0;
static int yoff;


MESH *siobj_load(char *name,int index)
{
short w;
int i;
int size;
short *buf;
int bi;	//buffer index.
MESH *obj;
SIRES_DESC	 *desc;
int verbose;
int flags;

//index=0x2c8-0x200;
	size=sires_load(name,index,(char**)&buf);
//	size=file_load("sort.bin",(char**)&buf);
//	size=file_load("sub3.bin",(char**)&buf);

file_write("out.bin",buf,size);
	if(size<=0)
		{
		conprintf("Can't load SIOBJ:%s\n",name);
		return(NULL);
		}

	desc=sires_get_desc(name,index);
//verbose=TRUE;

	if(verbose)
		if(desc)
	      conprintf("Decoding:%s:%x size:%x\n",desc->name,desc->id,size);

	bi=0;		//init index.

	w=buf[bi++];
	if(w!=OP_ID)
		FUNC_ERROR("Id not found");

	w=buf[bi++]; 	//dunno what this word is
	if(verbose)
		conprintf("SHAPESIZE %x:%d\n",w,w);

	w=buf[bi++];   //Y off ground.
	yoff=w;
	if(verbose)
		conprintf("Yoff:%d\n",yoff);

	w=buf[bi++]; //scale and flags in this word.
	flags=w>>8;	 //set flags
	w=w&0xff;	 //mask off flags

	if(verbose)
		if(flags)	  //only flag is 1 meaning FLAT
			conprintf("Flags: %x\n",flags);

	if(verbose)
		conprintf("Scale: %x:%d\n",w,w);
	
	if(w>17)
		conprintf("ERROR: Scale out of range:%d\n",w);

	scale=scale_table[w]/10;

	w=buf[bi++]; //collision. whatever that is?
	if(verbose)
		if(w)
			conprintf("Collision %x:%d\n",w,w);

		//clear out SIVERTEX and poly arrays.
	for(i=0;i<1100;i++)
		verts[i].flags=FALSE;
	for(i=0;i<1100;i++)
		polys[i].flags=FALSE;

	obj=mesh_create();

	indent=0; //for print out of parse
	if(siobj_parse(buf,bi,obj)==FALSE)
		{
		conprintf("Error loading SOD\n");
//		exit(-1);
//		obj=NULL;
		}
	free(buf);
	return(obj);
}

int sod_parse_ipg(ushort *buf,int bi)
{
int vert_index=0;
ushort w,w1,w2,w3,w4;

   w=buf[bi++];
	switch(w)
		{
		case 0:		//make a cube starting at vertex in w4
     		w1=buf[bi++];
  	      w2=buf[bi++];
       	w3=buf[bi++];
       	w4=buf[bi++]/0xc;
  			vert_index=w4;
  			//conprintf("IPG CUBE <%d,%d,%d>,%d\n",w,w1,w2,w3,w4);
  			set_vert(&verts[vert_index+7],0+w1,0+w2,0-w3);
  			set_vert(&verts[vert_index+6],0+w1,0+w2,0+w3);
  			set_vert(&verts[vert_index+5],0-w1,0+w2,0+w3);
  			set_vert(&verts[vert_index+4],0-w1,0+w2,0-w3);
  			set_vert(&verts[vert_index+3],0+w1,0-w2,0-w3);
  			set_vert(&verts[vert_index+2],0+w1,0-w2,0+w3);
  			set_vert(&verts[vert_index+1],0-w1,0-w2,0+w3);
  			set_vert(&verts[vert_index+0],0-w1,0-w2,0-w3);
  		  	break;
  		case 2:  //make a square starting at vertex in w4
      	w1=buf[bi++];
       	w2=buf[bi++];
       	w4=buf[bi++]/0xc;
  			vert_index=w4;
  			//conprintf("IPG GROUNDPTS <%d,%d>,%d\n",w,w1,w2,w4);
  			set_vert(&verts[vert_index+3],0+w1,0,0-w2);
  			set_vert(&verts[vert_index+2],0+w1,0,0+w2);
  			set_vert(&verts[vert_index+1],0-w1,0,0+w2);
  			set_vert(&verts[vert_index+0],0-w1,0,0-w2);
  		  	break;
  		case 8:  //make a square starting at vertex in w4
      	w1=buf[bi++];
       	w2=buf[bi++];
       	w4=buf[bi++]/0xc;
  			vert_index=w4;
  			//conprintf("IPG FLAT <%d,%d>,%d\n",w,w1,w2,w4);
  			set_vert(&verts[vert_index+3],0+w1,0-w2,0);
  			set_vert(&verts[vert_index+2],0+w1,0+w2,0);
  			set_vert(&verts[vert_index+1],0-w1,0+w2,0);
  			set_vert(&verts[vert_index+0],0-w1,0-w2,0);
  		  	break;
  		default:
      	w1=buf[bi++];
  			conprintf("IPG type wrong:%d @ %x -->%x\n",w,bi,w1);
  		  	break;
  		}
	return(bi);
}



int siobj_parse(short *buf,int bi,MESH *obj)
{
short w,w1,w2,w3,w4,w5;
int i;
int num;
int size;
int cur_color=0;
POLYGON *ply;
VECT *vt;
	while(1)	//loop 'till end of file
		{
		w=buf[bi++];
if (0)
{
if(w<0)
	exit(0);
for(i=0;i<indent;i++)
	conprintf(" ");
conprintf("Parsing %x-->OP:%s\n",bi-1,sod_op_desc[w/0x9]);
}		switch(w)
			{
			case OP_IPG:	 //initilize vertex cache
				bi=sod_parse_ipg(buf,bi);
				if(bi==0)
					return(FALSE);
				break;
			case OP_VECTORS:
				w=buf[bi++];			//number of verts
				w1=buf[bi++]/0xc;		//start register.
				//conprintf("VECTORS #%d Start:%d\n",w,w1);
				for(i=0;i<w;i++)
					{
					w2=buf[bi++];
					w3=buf[bi++];
					w4=buf[bi++];

					//HMM not sure why the -w3 clipper mast bug fix
               set_vert(&verts[w1],w2,-w3,w4);

					//conprintf("VEC %d ",w1);
					//dump_vert(&verts[w1]);
					//conprintf("\n");
					w1++;
					}
				break;
			case OP_GETV:
				w=buf[bi++]/0xc;
				get_vert(&cur_vert,&verts[w]);
				//conprintf("GETV %d ",w);
				//dump_vert(&cur_vert);
				//conprintf("\n");
				break;
			case OP_INTV:
				w=buf[bi++]/0xc;
				mid_vert(&cur_vert,&verts[w]);
				//conprintf("INTV %d ",w);
				//dump_vert(&verts[w]);
				//conprintf("\n");
				break;
			case OP_PUTV:
				w=buf[bi++]/0xc;
				get_vert(&verts[w],&cur_vert);
				//conprintf("PUTV %d ",w);
				//dump_vert(&cur_vert);
				//conprintf("\n");
				break;
			case OP_ADDV:
				w=buf[bi++]/0xc;
				add_vert(&cur_vert,&verts[w]);
				//conprintf("ADDV %d ",w);
				//dump_vert(&verts[w]);
				//conprintf("\n");
				break;
			case OP_SUBV:
				w=buf[bi++]/0xc;
				sub_vert(&cur_vert,&verts[w]);
				//conprintf("SUBV %d ",w);
				//dump_vert(&verts[w]);
				//conprintf("\n");
				break;
			case OP_SHRV:
				w=buf[bi++];
				shr_vert(&cur_vert,w);
				//conprintf("SHRV %d ",w);
				//dump_vert(&cur_vert);
				//conprintf("\n");
				break;
			case OP_SHLV:
				w=buf[bi++];
				shl_vert(&cur_vert,w);
				//conprintf("SHLV %d ",w);
				//dump_vert(&cur_vert);
				//conprintf("\n");
				break;
			case OP_NEGV:
				neg_vert(&cur_vert);
				//conprintf("NEGV ");
				//dump_vert(&cur_vert);
				//conprintf("\n");
				break;
			case OP_CLRV:
				set_vert(&cur_vert,0,0,0);
				//conprintf("CLRV");
				//dump_vert(&cur_vert);
				//conprintf("\n");
				break;
			case OP_PERS:
				w=buf[bi++];
				w1=buf[bi++];
				//conprintf("PERSPEC %d,%d\n",w1,w);
				break;
			case OP_REJ:
				w=buf[bi++];
				//conprintf("REJ3D %d\n",w);
				w=buf[bi++];
				//conprintf("Num Faces:%d\n",w);
				for(i=0;i<w;i++)
					{
           		w1=buf[bi++];
           		w2=buf[bi++];
           		w3=buf[bi++];
					//conprintf("face <%d,%d,%d>\n",w1/0xc,w2/0xc,w3/0xc);
					}
				break;
			case OP_VEC:

//*****Problems with this
conprintf("ERROR OP_VEC");
exit(-1);
//*****

        		w1=buf[bi++];
           	w2=buf[bi++];
           	w3=buf[bi++];
				//conprintf("vec <%d,%d,%d>\n",(int)w1,(int)w2,(int)w3);
				break;
			case OP_SPHERE:  //primitive not supported
        		w1=buf[bi++];
        		w2=buf[bi++];
				//conprintf("SPHERE %d,%d\n",(int)w1,(int)w2);
				break;
			case OP_BLOCK:    //primitive not supported
        		w1=buf[bi++];
        		w2=buf[bi++];
				//conprintf("BLOCK %d,%d\n",(int)w1,(int)w2);
				break;
			case OP_PERFDISK: //primitive not supported
        		w1=buf[bi++];
        		w2=buf[bi++];
        		w3=buf[bi++];
				//conprintf("PERFDISK %d,%d,%d\n",(int)w1,(int)w2,(int)w3);
				break;
			case OP_IFVIS:
				w=buf[bi++];
//				conprintf("IFVIS %d\n",w);
				w=buf[bi++]; //section size
//				conprintf("Size %x:%d\n",w);
//indent++;
//conprintf("in:%x\n",bi);
//				if(siobj_parse(buf,bi,obj)==FALSE)
//					return(FALSE);
//indent--;
//conprintf("out:%x\n",bi);
//				bi=bi+(w/2);
				break;
			case OP_COLOR:
				w=buf[bi++];
				cur_color=w;
				//conprintf("FILLCOLOR %d\n",w);
				break;
			case OP_LINECOL:
				w=buf[bi++];
				//conprintf("LINECOL %d\n",w);
				break;
			case OP_MOVETO:
				w=buf[bi++];
				//conprintf("MOVETO %d\n",w/0xc);
				break;
			case OP_ZLINETO:
				w=buf[bi++];
				//conprintf("ZLINETO %d\n",w/0xc);
				break;
			case OP_DOT:
				w=buf[bi++];
				//conprintf("DOT %d\n",w/0xc);
				break;
			case OP_POLYZ:
				//conprintf("POLYZ ");
				//conprintf("\n");
				w=buf[bi++];
				//conprintf("%d,",w);
				//conprintf("<");
				//polys[poly_index].num=0;
				//polys[poly_index].flags=TRUE;
				//polys[poly_index].color=cur_color;

				ply=polygon_create();
				ply->material=material_new(NULL,
											(float)sipal[(cur_color*3)+0]*(1.0/255.0),
											(float)sipal[(cur_color*3)+1]*(1.0/255.0),
											(float)sipal[(cur_color*3)+2]*(1.0/255.0) );
				for(i=0;i<w;i++)
					{
           		w1=buf[bi++]/0xc;

					vt=malloc(sizeof(VECT));
					vt->x=(float)-verts[w1].x*scale;
					vt->y=(float)(verts[w1].y+yoff)*scale;
					vt->z=(float)-verts[w1].z*scale;
					polygon_add_vert(ply,vt);

					//conprintf(" %d",w1);
               //polys[poly_index].v[polys[poly_index].num++]=w1;
					//dump_vert(&verts[w1]);
					}

				mesh_add_poly(obj,ply);
				//conprintf(">\n");
				//poly_index++;
				break;
			case OP_GVPOLY16:
			case OP_GVPOLY:
				//conprintf("GVPOLY ");
				num=buf[bi++];
				//conprintf("%d,%d",num,w);
				//conprintf("<");

				ply=polygon_create();
				ply->material=material_new(NULL,
											(float)sipal[(cur_color*3)+0]*(1.0/255.0),
											(float)sipal[(cur_color*3)+1]*(1.0/255.0),
											(float)sipal[(cur_color*3)+2]*(1.0/255.0) );
				for(i=0;i<num;i++)
					{
           		w1=buf[bi++]/0xc;

					vt=malloc(sizeof(VECT));
					vt->x=(float)-verts[w1].x*scale;
					vt->y=(float)(verts[w1].y+yoff)*scale;
					vt->z=(float)-verts[w1].z*scale;
					polygon_add_vert(ply,vt);
					}
				mesh_add_poly(obj,ply);
				w=buf[bi++]/0xc;
					//don't know/remember what this is.
				//conprintf(">,%d,<",w);
				for(i=0;i<num;i++)
					{
           		w1=buf[bi++];
					//conprintf("%d,",w1/2);
					}
				//conprintf(">\n");
				break;
			case OP_SHADES:
				w=buf[bi++];
//				conprintf("SHADES %d\n",w);
				w=buf[bi++];
				for(i=0;i<w;i++)
					{
	        		w1=buf[bi++];
   	        	w2=buf[bi++];
   	        	w3=buf[bi++];
//					conprintf("vec <%d,%d,%d>\n",(int)w1,(int)w2,(int)w3);
					}
				break;
			case 0x18c:
				w1=buf[bi++];
				w2=buf[bi++];
				w3=buf[bi++];
//				conprintf("SORT %x %x %x\n",(bi+(w1/2))-3,bi+(w2/2)-2,bi+(w3/2)-2);
indent++;
//conprintf("in:%x\n",bi);
					//gosub to next instruction
				if(siobj_parse(buf,bi,obj)==FALSE)
					return(FALSE);
					//gosub to second arg.
				if(siobj_parse(buf,bi+(w2/2)-2,obj)==FALSE)
					return(FALSE);
					//set pc to first arg.
            bi=(bi+(w1/2))-3;
indent--;
//conprintf("out:%x\n",bi);
				break;
			case 0x7e:	//push center
				conprintf("PUSH CENTER\n");
				break;
			case 0x87:	//pop center
				conprintf("POP CENTER\n");
				break;
			case 0x90:	//move center
				w1=buf[bi++];
				conprintf("MOVE CENTER: %d\n",w1);
				break;
			case OP_RETURN:
//				conprintf("RETURN:%x\n",bi);
				return(bi);
				break;

			case 0x1a7:	//gosub
				w1=buf[bi++];
				conprintf("GOSUB:%x\n",w1);
indent++;
				if(siobj_parse(buf,bi+(w1/2)-1,obj)==FALSE)
					return(FALSE);
indent--;
				break;
			case 0x22e:	//TAP whatever the fuck that is...
				conprintf("ACK: OP_TAP! Aborting.\n");
				return(FALSE);
				break;
			default:
				w1=buf[bi++];
				conprintf("ERROR Unknown op:%x:%d next %x:%d\n",w,w,w1,w1);
				conprintf("OPDESC:%s\n",sod_op_desc[w/0x9]);
				return(FALSE);
				break;

			}

		}
}














