#include <stdio.h>

#define TRUE 	(1)
#define FALSE 	(0)

char dbuf[8*1024*1024];
char buf[8*1024];

dump_file(char *rn,char *n,int p,int s)
{
FILE *fi,*fo;
char str[999];

	if(n==NULL)
      sprintf(str,"RES\\%06X.bin",p);
  	else
		sprintf(str,"RES\\%s.bin",n);

	mkdir("RES");

	fi=fopen(rn,"rb");
	fo=fopen(str,"wb");
	fseek(fi,p,SEEK_SET);
	fread(&dbuf[0],sizeof(char),s,fi);	
	fwrite(&dbuf[0],sizeof(char),s,fo);
	fclose(fi);
	fclose(fo);
}

int ofs[0x10000];

main(int ac,char *av[])
{
FILE *f;
int p,s,num;
short w;
int i;
char name[255];
int pos;
char resname[255];
int use_names=FALSE;

	if(ac<2)
		{
		printf("USAGE: RIPRES <-N> <resource>\n");
		printf("  Use the -N option to rip using object names (if availible).\n");
		printf("  NOTE: Not all resources have object names. See README.TXT\n");
		exit(-1);
		}

	for(i=0;i<ac;i++)
		{
		if(strstr(av[i],"-n") || strstr(av[i],"-N"))
			{
			use_names=TRUE;
			printf("RIPPING with names\n");
			}
		else
			sprintf(resname,"%s",av[i]);
		}
	
	f=fopen(resname,"rb");
	if(f==NULL)
		{
		puts("file not found\n");
		exit(-1);
		}

	fread(&w,sizeof(short),1,f);
	if(w!=('S'<<8)+'R')
		{
		puts("file not resource\n");
		exit(-1);
		}

	fread(&w,sizeof(short),1,f);
	fread(&ofs[0],sizeof(int),1,f);
	num=(ofs[0]/4)-1;
	for(i=1;i<num;i++)
		fread(&ofs[i],sizeof(int),1,f);

	printf("Ripping resource into %d files\n",num);
	if(use_names)
		{
		fseek(f,ofs[0],SEEK_SET);
		fread(&buf[0],sizeof(char),ofs[1]-ofs[0],f);
		for(i=0;i<ofs[1]-ofs[0];i++)
			{
			if(buf[i]==' ' ||buf[i]=='#' ||buf[i]=='/'||buf[i]=='&'||buf[i]=='.')
				buf[i]='_';

			if(buf[i])
				if(buf[i]<0x20 || buf[i]>0x7a)
					{
					printf("Resource contains no names.%d,%d\n",i,buf[i]);
					printf("Ignoring -N\n");
					use_names=FALSE;
					break;
					}
			}
		}
	pos=0;
	for(i=0;i<num-1;i++)
		{
		if(use_names)
			{
			printf("%08x:%s\n",ofs[i],&buf[pos]);
			dump_file(resname,&buf[pos],ofs[i],ofs[i+1]-ofs[i]);
			pos+=strlen(&buf[pos])+1;
			}
		else
			{

			dump_file(resname,NULL,ofs[i],ofs[i+1]-ofs[i]);
			}
		}
	fclose(f);
}



